#!/usr/bin/perl -w

#Le "Start of Image" JPEG
$SOI="\xFF\xD8";
#Le "End of Image"
$EOI="\xFF\xD9";

$TYPE = -1;

sub usage {
    print "Usage: searchjpg [--jfif|--exif] disk_image directory\n";
    print "This program can help you to recover JPEG pictures from a disk image.\n";
    print "\t 'disk_image' must be a physical disk image (made with dd)\n";
    print "\t 'directory' must indicate the path where you would store\n";
    print "\t\trecovered pictures (pictures are named 'extractedX.jpg'\n";
    print "\t\twhere 'X' is a number. Former files with the same name will\n";
    print "\t\tbe erased!\n";
    print "\n\tOPTIONS:\n";
    print "\t '--jfif' performs more tests and recovers JFIF pictures only \n";
    print "\t\t(= standard JPEG)\n";
    print "\t '--exif' performs more tests and recovers Exif pictures only (usefull\n";
    print "\t\tto recover digital cams photographies).\n";
    print "\t '--help' prints this message\n";
    print "By default, this program only do tests on 'SOI' & 'EOI' tags and may not\n";
    print "recover properly Exif pictures with thumbnails.\n";

    print "\n\tCAUTION: Use at your own risks!!!\n";
    print "This program is distributed in the hope that it will be useful,\n";
    print "but WITHOUT ANY WARRANTY; without even the implied warranty of\n";
    print "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n";
    print "GNU General Public License for more details.\n";

    print "\nPermission is granted to copy, distribute and/or modify this program\n";
    print "under the terms of the Gnu Public License version 2.\n";
    print "Copyleft 2002 Nicolas Bernard. All rights renversed.\n";
    exit 1;
}

if ((@ARGV < 2) || (@ARGV > 3)) {
    usage ;
}

if (@ARGV == 2) {
    $FICHIER = $ARGV[0];
    $REP = $ARGV[1];
    $TYPE = 0;
} elsif (@ARGV == 3) {
    $FICHIER = $ARGV[1];
    $REP = $ARGV[2];
    if ($ARGV[0] eq '--jfif') {
	$TYPE = 1;
    } elsif ($ARGV[0] eq '--exif') {
	$TYPE = 2;
    } else {
	usage;
    }
}

$compteur=0;

chdir $REP || die "Impossible d'aller dans $REP\n" ;
open SEARCH, "$FICHIER" or die "Impossible d'ouvrir le fichier $FICHIER\n";
print "Recherche d'images JPEG dans le fichier $FICHIER\n";

$var = "";
DEBUT:
    print "recherche N$compteur\n";

if ($TYPE == 1) { #JFIF
    (defined ($var = <SEARCH>) || exit 0) until ($var =~ m/($SOI[\x00-\xFF]{4}JFIF\x00[\x00-\xFF]*)($SOI)?/);
    open OUTP, ">$REP/extracted$compteur.jpg" or die "Impossible d'ouvrir le fichier \"$REP/coucou\"\n";
    print OUTP $1;
    if (defined $2) {
	print OUTP $2;
	goto FIN;
    }
} elsif ($TYPE == 0) { # on rcupre tout... et plus encore ;-)
    (defined ($var = <SEARCH>) || exit 0) until ($var =~ m/($SOI[\x00-\xFF]*)($SOI)?/);
    open OUTP, ">$REP/extracted$compteur.jpg" or die "Impossible d'ouvrir le fichier \"$REP/coucou\"\n";
    print OUTP $1;
    if (defined $2) {
	print OUTP $2;
	goto FIN;
    }
} else { # EXIF
    (defined ($var = <SEARCH>) || exit 0) until ($var =~ m/($SOI\xFF\xE1[\x00-\xFF]{2}Exif\x00\x00[\x00-\xFF]*)($SOI)?/);
    open OUTP, ">$REP/extracted$compteur.jpg" or die "Impossible d'ouvrir le fichier \"$REP/coucou\"\n";
    print OUTP $1;
    if (defined $2) {
	print OUTP $2;
	goto FIN;
    }
}

$nb = 0; # compteur car le format exif contient (gnralement) une miniature qui se termine par un EOI...
$var = <SEARCH>;
VERSFIN:
if (!($var =~ m/([\x00-\xFF]*$EOI)$/)) {
    do {
	print OUTP $var;
	$var = <SEARCH>;
    } until ($var =~ m/$EOI/);
}
if (($TYPE == 2) && ($nb == 0)) {
    $nb = 1;
    print OUTP $var;
    $var = <SEARCH>;
    goto VERSFIN;
}
if ($var =~ m/([\x00-\xFF]*$EOI)/) {
    print OUTP $1;
} else { die "erreur inconnue\n";}
close OUTP;

FIN:
print "image (?)  rcupre dans \"$REP/extracted$compteur.jpg\"\n";
$compteur++;

goto DEBUT;
